#include "vector.hpp"
#include <iostream>

void multiply_all(vector& v, double factor) {
    for (size_t i = 0; i < v.size(); i++) {
        v[i] *= factor;
    }
}

double accumulate(const vector& v) {
    double sum = 0;

    for (size_t i = 0; i < v.size(); i++) {
        sum += v[i];
    }

    return sum;
}

vector cat(vector v) {
    auto original_size = v.size();
    v.resize(v.size() * 2);
    for (size_t i = 0; i < original_size; ++i) {
        v[original_size + i] = v[i];
    }
    return v;
}

int main() {
    vector v1;
    v1.push_back(1.23);
    v1.push_back(2.34);
    vector v2 = v1;            // kopirujici konstruktor
    vector v3 = std::move(v2); // presunujici konstruktor
    vector v4 = cat(v3);       // kopirujici konstuktor a presunujici konstruktor

    std::cout << "v1: " << v1;
    std::cout << "v2: " << v2;
    std::cout << "v3: " << v3;
    std::cout << "v4: " << v4;

    vector v5;
    v5.push_back(1.23);
    v5.push_back(2.34);
    vector v6;
    v6 = v5;                   // kopirujici prirazeni
    vector v7;
    v7 = std::move(v6);        // presunujici prirazeni
    vector v8;
    v8 = cat(v7);              // kopirujici konstruktor a presunujici prirazeni

    std::cout << "v5: " << v5;
    std::cout << "v6: " << v6;
    std::cout << "v7: " << v7;
    std::cout << "v8: " << v8;
}
